function x = FD2Synthesis(w, n)

e1 = n*(n-2);
t1 = reshape(w(1:e1), n, n-2);
e2 = e1 + n*(n-2);
t2 = reshape(w((e1+1):e2), n-2, n);
e3 = e2 + (n-2)*(n-2);
t3 = reshape(w((e2+1):e3), n-2, n-2);
t4 = reshape(w((e3+1):end), n-2, n-2);

x = zeros(n, n);
x(:, 3:end) = t1;
x(:, 2:(end-1)) = x(:, 2:(end-1)) - 2*t1;
x(:, 1:(end-2)) = x(:, 1:(end-2)) + t1;

x(3:end, :) = x(3:end, :) + t2;
x(2:(end-1), :) = x(2:(end-1), :) - 2*t2;
x(1:(end-2), :) = x(1:(end-2), :) + t2;

x(3:end, 3:end) = x(3:end, 3:end) + t3;
x(2:(end-1), 2:(end-1)) = x(2:(end-1), 2:(end-1)) - 2*t3 - 2*t4;
x(1:(end-2), 1:(end-2)) = x(1:(end-2), 1:(end-2)) + t3;

x(3:end, 1:(end-2)) = x(3:end, 1:(end-2)) + t4;
x(1:(end-2), 3:end) = x(1:(end-2), 3:end) + t4;

x = x(:);
