function Omega = Generate_Analysis_Operator(d, p)

% generate random tight frame with equal column norms

if p == d
    T = randn(d);
    [Omega, discard] = qr(T);
else
    Omega = randn(p, d);
    T = zeros(p, d);
    tol = 1e-8;
    max_j = 200;
    j = 1;
    while sum(sum(abs(T-Omega))) > tol*(p*d) && j < max_j
        j = j + 1;
        T = Omega;
        [U, S, V] = svd(Omega);
        Omega = U * [eye(d); zeros(p-d,d)] * V';
        Omega = diag(1./sqrt(diag(Omega*Omega')))*Omega;
    end
    %disp(j);
end
